<?php function is_mysqli_or_resource($r) { switch(gettype($r)) { case 'resource': return true; case 'object': if ($r instanceof mysqli) { return !($r->connect_error); } if ($r instanceof mysqli_result) { return true; } return false; default: return false; }}function is_mysql_resource($r) { return is_mysqli_or_resource($r);}function is_generic_resource($r) { return is_mysqli_or_resource($r);}function is_mysql_resource_old($result) { if (extension_loaded('mysql')) { return is_resource($result); } if (extension_loaded('mysqli')) { return is_object($result); } echo 'Fatal error, mysqli extension not loaded.'."\n"; die(1);}if (!extension_loaded('mysql')) { if (!extension_loaded('mysqli')) { echo 'Fatal error, mysqli extension not loaded.'."\n"; die(1); } $mysql_links = array(); if (!defined('MYSQL_DEFAULT_HOST')) { if (ini_get('mysqli.default_host') !== false) { define('MYSQL_DEFAULT_HOST', ini_get('mysqli.default_host')); } else { define('MYSQL_DEFAULT_HOST', ini_get('mysql.default_host')); } } if (!defined('MYSQL_DEFAULT_USER')) { if (ini_get('mysqli.default_user') !== false) { define('MYSQL_DEFAULT_USER', ini_get('mysqli.default_user')); } else { define('MYSQL_DEFAULT_USER', ini_get('mysql.default_user')); } } if (!defined('MYSQL_DEFAULT_PASSWORD')) { if (ini_get('mysqli.default_pw') !== false) { define('MYSQL_DEFAULT_PASSWORD', ini_get('mysqli.default_pw')); } else { define('MYSQL_DEFAULT_PASSWORD', ini_get('mysql.default_password')); } } define('MYSQL_CLIENT_COMPRESS', MYSQLI_CLIENT_COMPRESS); define('MYSQL_CLIENT_IGNORE_SPACE', MYSQLI_CLIENT_IGNORE_SPACE); define('MYSQL_CLIENT_INTERACTIVE', MYSQLI_CLIENT_INTERACTIVE); define('MYSQL_CLIENT_SSL', MYSQLI_CLIENT_SSL); define('MYSQL_ASSOC', MYSQLI_ASSOC); define('MYSQL_BOTH', MYSQLI_BOTH); define('MYSQL_NUM', MYSQLI_NUM); function mysql_field_bitflags_to_flags($flags_num) { $flags = array(); $constants = get_defined_constants(true); foreach ($constants['mysqli'] as $c => $n) { if (preg_match('/MYSQLI_(.*)_FLAG$/', $c, $m)) { if (!array_key_exists($n, $flags)) { $flags[$n] = $m[1]; } } } $result = array(); foreach ($flags as $n => $t) { if ($flags_num & $n) { $result[] = $t; } } return implode(' ', $result); } function mysql_field_bittypes_to_types($type_id) { $types = array(); $constants = get_defined_constants(true); foreach ($constants['mysqli'] as $c => $n) { if (preg_match('/^MYSQLI_TYPE_(.*)/', $c, $m)) { $types[$n] = $m[1]; } } if (array_key_exists($type_id, $types)) { return $types[$type_id]; } return NULL; } function mysql_ensure_link($link_identifier) { if ($link_identifier === NULL) { global $mysql_links; if (!count($mysql_links)) { return NULL; } $last = end($mysql_links); return $last['link']; } return $link_identifier; } function mysql_affected_rows($link_identifier = NULL) { return mysqli_affected_rows( mysql_ensure_link($link_identifier) ); } function mysql_client_encoding($link_identifier = NULL) { return mysqli_character_set_name( mysql_ensure_link($link_identifier) ); } function mysql_close($link = NULL) { global $mysql_links; $link = mysql_ensure_link($link); if (isset($link->thread_id) && is_numeric($link->thread_id)) { $thread_id = $link->thread_id; } else { $thread_id = false; } $result = mysqli_close($link); if ($result && $thread_id) { foreach ($mysql_links as $k => $v) { if ($v['thread_id'] === $thread_id) { array_splice($mysql_links, $k, 1); break; } } } else if ($result === null) { return false; } return $result; } function mysql_connect( $server = MYSQL_DEFAULT_HOST, $username = MYSQL_DEFAULT_USER, $password = MYSQL_DEFAULT_PASSWORD, $new_link = false, $client_flags = 0 ) { global $mysql_links; if (!$new_link) { global $mysql_links; if ($mysql_links && count($mysql_links)) { $last = end($mysql_links); if ( $server === $last['server'] && $username === $last['username'] && $password === $last['password'] && is_resource($last['link']) ) { return mysql_ensure_link(NULL); } } } $link = mysqli_connect($server, $username, $password, ''); if (mysqli_connect_errno()) { return false; } $mysql_links[] = array( 'thread_id' => $link->thread_id, 'server' => $server, 'username' => $username, 'password' => $password, 'link' => $link ); return $link; } function mysql_createdb($database_name, $link_identifier = NULL) { $link_identifier = mysql_ensure_link($link_identifier); return mysqli_query( $link_identifier, 'CREATE DATABASE '.mysqli_real_escape_string( $link_identifier, $database_name ) ); } function mysql_create_db($database_name, $link_identifier = NULL) { $link_identifier = mysql_ensure_link($link_identifier); return mysqli_query( $link_identifier, 'CREATE DATABASE '.mysqli_real_escape_string( $link_identifier, $database_name ) ); } function mysql_data_seek($result, $row_number) { return mysqli_data_seek($result, $row_number); } function mysql_db_name($result, $row, $field = NULL) { $field = $field === null ? 0 : $field; if (mysqli_data_seek($result, $row) === false) { return false; } $row = mysqli_fetch_array($result); if ($row === NULL) { return $row; } if (!isset($row[$field])) { return false; } return $row[$field]; } function mysql_dbname($result, $row, $field = NULL) { if (mysqli_data_seek($result, $row) === false) { return false; } $row = mysqli_fetch_array($result); if ($row === NULL) { return $row; } if (!isset($row[$field])) { return false; } return $row[$field]; } function mysql_db_query($database, $query, $link_identifier = NULL) { if (mysqli_select_db($link_identifier, $database) !== true) { return false; } return mysqli_query($link_identifier, $query); } function mysql_drop_db($database_name, $link_identifier = NULL) { return mysqli_query( $link_identifier, 'DROP DATABASE '. mysqli_real_escape_string( $link_identifier, $database_name ) ); } function mysql_errno($link_identifier = NULL) { return mysqli_errno (mysql_ensure_link($link_identifier)); } function mysql_error($link_identifier = NULL) { return mysqli_error(mysql_ensure_link($link_identifier)); } function mysql_escape_string($unescaped_string) { return mysqli_real_escape_string( mysql_ensure_link(NULL), $unescaped_string ); } function mysql_fetch_array($result, $result_type = MYSQL_BOTH) { return mysqli_fetch_array($result, $result_type); } function mysql_fetch_assoc($result) { return mysqli_fetch_assoc($result); } function mysql_fetch_field($result, $field_offset = NULL) { if (is_numeric($field_offset)) { mysqli_field_seek($result, $field_offset); } return mysqli_fetch_field($result); } function mysql_fetch_lengths($result) { return mysqli_fetch_lengths($result); } function mysql_fetch_object($result, $class_name = NULL, $params = NULL ) { if ($class_name !== NULL && $params !== NULL) { $t = mysqli_fetch_object($result, $class_name, $params); } else if ($class_name !== NULL) { $t = mysqli_fetch_object($result, $class_name); } else { $t = mysqli_fetch_object($result); } if ($t === NULL) { return false; } return $t; } function mysql_fetch_row($result) { return mysqli_fetch_row($result); } function mysql_field_flags($result, $field_offset) { $t = mysqli_fetch_field_direct($result, $field_offset); if (!is_object($t)) return $t; $t = (array)$t; if (isset($t['flags'])) { return mysql_field_bitflags_to_flags($t['flags']); } return NULL; } function mysql_field_len($result, $field_offset) { $t = mysqli_fetch_field_direct($result, $field_offset); if (!is_object($t)) return $t; $t = (array)$t; return isset($t['length']) ? $t['length'] : NULL; } function mysql_field_name($result, $field_offset) { $t = mysqli_fetch_field_direct($result, $field_offset); if (!is_object($t)) return $t; $t = (array)$t; return isset($t['name']) ? $t['name'] : NULL; } function mysql_field_seek($result, $field_offset) { return mysqli_field_seek($result, $field_offset); } function mysql_field_table($result, $field_offset) { $t = mysqli_fetch_field_direct($result, $field_offset); if (!is_object($t)) return $t; $t = (array)$t; return isset($t['table']) ? $t['table'] : NULL; } function mysql_field_type($result, $field_offset) { $t = mysqli_fetch_field_direct($result, $field_offset); if (!is_object($t)) return $t; $t = (array)$t; if (isset($t['type'])) { return mysql_field_bittypes_to_types($t['type']); } return NULL; } function mysql_free_result($result) { mysqli_free_result($result); return true; } function mysql_get_client_info($link_identifier = null) { return mysqli_get_client_info( mysql_ensure_link($link_identifier) ); } function mysql_get_host_info($link_identifier = NULL) { return mysqli_get_host_info( mysql_ensure_link($link_identifier) ); } function mysql_get_proto_info($link_identifier = NULL) { return mysqli_get_proto_info( mysql_ensure_link($link_identifier) ); } function mysql_get_server_info($link_identifier = NULL) { return mysqli_get_server_info( mysql_ensure_link($link_identifier) ); } function mysql_info($link_identifier = NULL) { return mysqli_info( mysql_ensure_link($link_identifier) ); } function mysql_insert_id($link_identifier = NULL) { return mysqli_insert_id( mysql_ensure_link($link_identifier) ); } function mysql_list_dbs($link_identifier = NULL) { global $mysql_list_dbs_cache; $t = mysqli_query( mysql_ensure_link($link_identifier), 'SHOW DATABASES' ); $mysql_list_dbs_cache = $t; return $t; } function mysql_list_fields($database_name, $table_name, $link_identifier = NULL ) { $link_identifier = mysql_ensure_link($link_identifier); return mysqli_query( $link_identifier, 'SHOW COLUMNS FROM '. mysqli_real_escape_string($link_identifier, $database_name). '.`'. mysqli_real_escape_string($link_identifier, $table_name). '`' ); } function mysql_list_processes($link_identifier = NULL) { return mysqli_query( mysql_ensure_link($link_identifier), 'SHOW PROCESSLIST' ); } function mysql_list_tables($database_name, $table_name, $link_identifier = NULL ) { $link_identifier = mysql_ensure_link($link_identifier); return mysqli_query( $link_identifier, 'SHOW TABLES FROM '. mysqli_real_escape_string($link_identifier, $database_name) ); } function mysql_num_fields($result) { $t = mysqli_fetch_fields($result); if ($t === null) { return $t; } return count($t); } function mysql_num_rows($result) { return mysqli_num_rows($result); } function mysql_pconnect($server = MYSQL_DEFAULT_HOST, $username = MYSQL_DEFAULT_USER, $password = MYSQL_DEFAULT_PASSWORD, $client_flags = 0 ) { return mysql_connect( 'p:'.$server, $username, $password, true, $client_flags ); } function mysql_ping($link_identifier = NULL) { return mysqli_ping(mysql_ensure_link($link_identifier)); } function mysql_query($query, $link_identifier = NULL) { return mysqli_query(mysql_ensure_link($link_identifier), $query); } function mysql_real_escape_string($unescaped_string, $link_identifier = NULL ) { return mysqli_real_escape_string( mysql_ensure_link($link_identifier), $unescaped_string ); } function mysql_result($result, $row, $field = 0) { if (mysqli_data_seek($result, $row) === false) return false; $row = mysqli_fetch_array($result); if ($row === NULL) return $row; if (!array_key_exists($field, $row)) { $row = array_change_key_case($row, CASE_LOWER); $field = strtolower($field); if (!array_key_exists($field, $row)) { return false; } } return $row[$field]; } function mysql_select_db($database_name, $link_identifier = NULL) { return mysqli_select_db( mysql_ensure_link($link_identifier), $database_name ); } function mysql_selectdb($database_name, $link_identifier = NULL) { return mysql_select_db ($database_name, $link_identifier = NULL); } function mysql_set_charset($charset, $link_identifier = NULL) { return mysqli_set_charset( mysql_ensure_link($link_identifier), $charset ); } function mysql_stat($link_identifier = NULL) { $t = mysqli_stat(mysql_ensure_link($link_identifier)); if ($t === FALSE) { return NULL; } return $t; } function mysql_tablename($result, $i) { $row = $i; $field = 0; if (mysqli_data_seek($result, $row) === false) { return false; } $row = mysqli_fetch_array($result); if ($row === NULL) { return $row; } if (!isset($row[$field])) { return false; } return $row[$field]; } function mysql_thread_id($link_identifier = NULL) { return mysqli_thread_id(mysql_ensure_link($link_identifier)); } function mysql_unbuffered_query($query, $link_identifier = NULL) { return mysqli_query( mysql_ensure_link($link_identifier), $query, MYSQLI_USE_RESULT ); }} ?>